scala

# Console

#### object Console

Implements functionality for printing Scala values on the terminal as well as reading specific values. Also defines constants for marking up text on ANSI terminals.

Source
  Console.scala
Version

  1.0, 03/09/2003

Linear Supertypes
AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Console
2. AnyRef
3. Any

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

5. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality. The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

6. #### final val BLACK: String("\033[30m")

   Foreground color for ANSI black

7. #### final val BLACK_B: String("\033[40m")

   Background color for ANSI black

8. #### final val BLINK: String("\033[5m")

   ANSI blink

9. #### final val BLUE: String("\033[34m")

   Foreground color for ANSI blue

10. #### final val BLUE_B: String("\033[44m")

    Background color for ANSI blue

11. #### final val BOLD: String("\033[1m")

    ANSI bold

12. #### final val CYAN: String("\033[36m")

    Foreground color for ANSI cyan

13. #### final val CYAN_B: String("\033[46m")

    Background color for ANSI cyan

14. #### final val GREEN: String("\033[32m")

    Foreground color for ANSI green

15. #### final val GREEN_B: String("\033[42m")

    Background color for ANSI green

16. #### final val INVISIBLE: String("\033[8m")

    ANSI invisible

17. #### final val MAGENTA: String("\033[35m")

    Foreground color for ANSI magenta

18. #### final val MAGENTA_B: String("\033[45m")

    Background color for ANSI magenta

19. #### final val RED: String("\033[31m")

    Foreground color for ANSI red

20. #### final val RED_B: String("\033[41m")

    Background color for ANSI red

21. #### final val RESET: String("\033[0m")

    Reset ANSI styles

22. #### final val REVERSED: String("\033[7m")

    ANSI reversed

23. #### final val UNDERLINED: String("\033[4m")

    ANSI underlines

24. #### final val WHITE: String("\033[37m")

    Foreground color for ANSI white

25. #### final val WHITE_B: String("\033[47m")

    Background color for ANSI white

26. #### final val YELLOW: String("\033[33m")

    Foreground color for ANSI yellow

27. #### final val YELLOW_B: String("\033[43m")

    Background color for ANSI yellow

28. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

29. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

30. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

31. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

32. #### def err: PrintStream

    The default error, can be overridden by `setErr`

33. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

34. #### def flush(): Unit

    Flushes the output stream.

    Flushes the output stream. This function is required when partial output (i.e. output not terminated by a newline character) has to be made visible on the terminal.

35. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

36. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

37. #### def in: BufferedReader

    The default input, can be overridden by `setIn`

38. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

39. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

40. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

41. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

42. #### def out: PrintStream

    The default output, can be overridden by `setOut`

43. #### def print(obj: Any): Unit

    Prints an object to `out` using its `toString` method.

    Prints an object to `out` using its `toString` method.

    obj

      the object to print; may be null.

44. #### def printf(text: String, args: Any*): Unit

    Prints its arguments as a formatted string to the default output, based on a string pattern (in a fashion similar to printf in C).

    Prints its arguments as a formatted string to the default output, based on a string pattern (in a fashion similar to printf in C).

    The interpretation of the formatting patterns is described in `java.util.Formatter`.

    text

      the pattern for formatting the arguments.

    args

      the arguments used to instantiating the pattern.

    Exceptions thrown
      java.lang.IllegalArgumentException

      if there was a problem with the format string or arguments

45. #### def println(x: Any): Unit

    Prints out an object to the default output, followed by a newline character.

    Prints out an object to the default output, followed by a newline character.

    x

      the object to print.

46. #### def println(): Unit

    Prints a newline character on the default output.

47. #### def readBoolean(): Boolean

    Reads a boolean value from an entire line of the default input.

    Reads a boolean value from an entire line of the default input. Has a fairly liberal interpretation of the input.

    returns

      the boolean value read, or false if it couldn't be converted to a boolean

    Exceptions thrown
      java.io.EOFException

      if the end of the input stream has been reached.

48. #### def readByte(): Byte

    Reads a byte value from an entire line of the default input.

    Reads a byte value from an entire line of the default input.

    returns

      the Byte that was read

    Exceptions thrown
      java.io.EOFException

      if the end of the input stream has been reached.

      java.lang.NumberFormatException

      if the value couldn't be converted to a Byte

49. #### def readChar(): Char

    Reads a char value from an entire line of the default input.

    Reads a char value from an entire line of the default input.

    returns

      the Char that was read

    Exceptions thrown
      java.io.EOFException

      if the end of the input stream has been reached.

      java.lang.StringIndexOutOfBoundsException

      if the line read from default input was empty

50. #### def readDouble(): Double

    Reads a double value from an entire line of the default input.

    Reads a double value from an entire line of the default input.

    returns

      the Double that was read.

    Exceptions thrown
      java.io.EOFException

      if the end of the input stream has been reached.

      java.lang.NumberFormatException

      if the value couldn't be converted to a Float

51. #### def readFloat(): Float

    Reads a float value from an entire line of the default input.

    Reads a float value from an entire line of the default input.

    returns

      the Float that was read.

    Exceptions thrown
      java.io.EOFException

      if the end of the input stream has been reached.

      java.lang.NumberFormatException

      if the value couldn't be converted to a Float

52. #### def readInt(): Int

    Reads an int value from an entire line of the default input.

    Reads an int value from an entire line of the default input.

    returns

      the Int that was read

    Exceptions thrown
      java.io.EOFException

      if the end of the input stream has been reached.

      java.lang.NumberFormatException

      if the value couldn't be converted to an Int

53. #### def readLine(text: String, args: Any*): String

    Print formatted text to the default output and read a full line from the default input.

    Print formatted text to the default output and read a full line from the default input. Returns `null` if the end of the input stream has been reached.

    text

      the format of the text to print out, as in `printf`.

    args

      the parameters used to instantiate the format, as in `printf`.

    returns

      the string read from the default input

54. #### def readLine(): String

    Read a full line from the default input.

    Read a full line from the default input. Returns `null` if the end of the input stream has been reached.

    returns

      the string read from the terminal or null if the end of stream was reached.

55. #### def readLong(): Long

    Reads an long value from an entire line of the default input.

    Reads an long value from an entire line of the default input.

    returns

      the Long that was read

    Exceptions thrown
      java.io.EOFException

      if the end of the input stream has been reached.

      java.lang.NumberFormatException

      if the value couldn't be converted to a Long

56. #### def readShort(): Short

    Reads a short value from an entire line of the default input.

    Reads a short value from an entire line of the default input.

    returns

      the short that was read

    Exceptions thrown
      java.io.EOFException

      if the end of the input stream has been reached.

      java.lang.NumberFormatException

      if the value couldn't be converted to a Short

57. #### def readf(format: String): List[Any]

    Reads in some structured input (from the default input), specified by a format specifier.

    Reads in some structured input (from the default input), specified by a format specifier. See class `java.text.MessageFormat` for details of the format specification.

    format

      the format of the input.

    returns

      a list of all extracted values.

    Exceptions thrown
      java.io.EOFException

      if the end of the input stream has been reached.

58. #### def readf1(format: String): Any

    Reads in some structured input (from the default input), specified by a format specifier, returning only the first value extracted, according to the format specification.

    Reads in some structured input (from the default input), specified by a format specifier, returning only the first value extracted, according to the format specification.

    format

      format string, as accepted by `readf`.

    returns

      The first value that was extracted from the input

59. #### def readf2(format: String): (Any, Any)

    Reads in some structured input (from the default input), specified by a format specifier, returning only the first two values extracted, according to the format specification.

    Reads in some structured input (from the default input), specified by a format specifier, returning only the first two values extracted, according to the format specification.

    format

      format string, as accepted by `readf`.

    returns

      A scala.Tuple2 containing the first two values extracted

60. #### def readf3(format: String): (Any, Any, Any)

    Reads in some structured input (from the default input), specified by a format specifier, returning only the first three values extracted, according to the format specification.

    Reads in some structured input (from the default input), specified by a format specifier, returning only the first three values extracted, according to the format specification.

    format

      format string, as accepted by `readf`.

    returns

      A scala.Tuple3 containing the first three values extracted

61. #### def setErr(err: OutputStream): Unit

    Sets the default error stream.

    Sets the default error stream.

    err

      the new error stream.

62. #### def setErr(err: PrintStream): Unit

    Sets the default error stream.

    Sets the default error stream.

    err

      the new error stream.

63. #### def setIn(in: InputStream): Unit

    Sets the default input stream.

    Sets the default input stream.

    in

      the new input stream.

64. #### def setIn(reader: Reader): Unit

    Sets the default input stream.

    Sets the default input stream.

    reader

      specifies the new input stream.

65. #### def setOut(out: OutputStream): Unit

    Sets the default output stream.

    Sets the default output stream.

    out

      the new output stream.

66. #### def setOut(out: PrintStream): Unit

    Sets the default output stream.

    Sets the default output stream.

    out

      the new output stream.

67. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

68. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

69. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

70. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

71. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

72. #### def withErr[T](err: OutputStream)(thunk: ⇒ T): T

    Sets the default error stream for the duration of execution of one thunk.

    Sets the default error stream for the duration of execution of one thunk.

    err

      the new error stream.

    thunk

      the code to execute with the new error stream active

    returns

      the results of `thunk`

    See also

      `withErr[T](err:PrintStream)(thunk: =>T)`

73. #### def withErr[T](err: PrintStream)(thunk: ⇒ T): T

    Set the default error stream for the duration of execution of one thunk.

    Set the default error stream for the duration of execution of one thunk.

    err

      the new error stream.

    thunk

      the code to execute with the new error stream active

    returns

      the results of `thunk`

    Example:

    1.     withErr(Console.out) { println("This goes to default _out_") }

    See also

      `withErr[T](err:OutputStream)(thunk: =>T)`

74. #### def withIn[T](in: InputStream)(thunk: ⇒ T): T

    Sets the default input stream for the duration of execution of one thunk.

    Sets the default input stream for the duration of execution of one thunk.

    in

      the new input stream.

    thunk

      the code to execute with the new input stream active

    returns

      the results of `thunk`

    See also

      `withIn[T](reader:Reader)(thunk: =>T)`

75. #### def withIn[T](reader: Reader)(thunk: ⇒ T): T

    Sets the default input stream for the duration of execution of one thunk.

    Sets the default input stream for the duration of execution of one thunk.

    thunk

      the code to execute with the new input stream active

    returns

      the results of `thunk`

    Example:

    1.     val someFile:Reader = openFile("file.txt")
           withIn(someFile) {
             // Reads a line from file.txt instead of default input
             println(readLine)
           }

    See also

      `withIn[T](in:InputStream)(thunk: =>T)`

76. #### def withOut[T](out: OutputStream)(thunk: ⇒ T): T

    Sets the default output stream for the duration of execution of one thunk.

    Sets the default output stream for the duration of execution of one thunk.

    out

      the new output stream.

    thunk

      the code to execute with the new output stream active

    returns

      the results of `thunk`

    See also

      `withOut[T](out:PrintStream)(thunk: => T)`

77. #### def withOut[T](out: PrintStream)(thunk: ⇒ T): T

    Sets the default output stream for the duration of execution of one thunk.

    Sets the default output stream for the duration of execution of one thunk.

    out

      the new output stream.

    thunk

      the code to execute with the new output stream active

    returns

      the results of `thunk`

    Example:

    1.     withOut(Console.err) { println("This goes to default _error_") }

    See also

      `withOut[T](out:OutputStream)(thunk: => T)`

### Inherited from AnyRef

### Inherited from Any

### Ungrouped